function SRBC:IsPlayerMobj(p)
	return p and p.valid and p.mo and p.mo.valid and p.srbc
end

function SRBC:IsMobjPlayer(mobj)
	return mobj and mobj.valid and mobj.player and mobj.player.valid and mobj.player.srbc
end

function SRBC:IsChasers()
	return gametype == GT_CHASERS
end



function SRBC:StopM(mobj)
	mobj.momx = 0
	mobj.momy = 0
	mobj.momz = 0
end

function SRBC:StoreM(p)
	if SRBC:IsPlayerMobj(p) then
		p.srbc.storedMomentum.x = p.mo.momx
		p.srbc.storedMomentum.y = p.mo.momy
		p.srbc.storedMomentum.z = p.mo.momz
	end
end

function SRBC:ReleaseM(p)
	if SRBC:IsPlayerMobj(p) then
		p.mo.momx = p.srbc.storedMomentum.x
		p.mo.momy = p.srbc.storedMomentum.y
		p.mo.momz = p.srbc.storedMomentum.z
	end
end



function SRBC:TicsToTime(tics, cents)
	if tics == nil then return "error" end
	
	local result = tostring(G_TicsToMinutes(tics, true))
	
	local timestring = tostring(G_TicsToSeconds(tics))
	if timestring:len() < 2 then timestring = "0"..timestring end
	result = $..":"..timestring
	
	if cents then
		timestring = tostring(G_TicsToCentiseconds(tics))
		if timestring:len() < 2 then timestring = "0"..timestring end
		result = $.."."..timestring
	end
	
	return result
end

function SRBC:Timestamp()
	return max(leveltime, 1)
end

function SRBC:TimeSince(timestamp)
	if type(timestamp) == "number" then
		if timestamp == 0 then
			return 0
		else
			return max(0, leveltime - timestamp)
		end
	end
end

function SRBC:SinceStart()
	return max(0, SRBC:TimeSince(SRBC.gamestate.started) - SRBC:TimeSince(SRBC.gamestate.gameover))
end

function SRBC:SinceOvertime()
	return max(0, SRBC:TimeSince(SRBC.gamestate.overtime) - SRBC:TimeSince(SRBC.gamestate.gameover))
end

function SRBC:PlayerOvertime(p)
	return max(0, p.srbc.overtime - (SRBC:TimeSince(SRBC.gamestate.overtime) - SRBC:TimeSince(p.srbc.over)))
end