-- signal(i)s
-- signals are not net synced under the assumption they won't be dynamically created rn.

-- holding onto this for myselfVV
--[[
	if SRBC.CallHook("HookName", etc, etc) then return end
]]

local Connections = {
	["ChaseStarting"] = {override = true, funcs = {}},
	["ChaseStarted"] = {override = false, funcs = {}},
	["OvertimeStarting"] = {override = true, funcs = {}},
	["OvertimeStarted"] = {override = false, funcs = {}},
	["PlayerLap"] = {override = true, funcs = {}},
	["PlayerFinish"] = {override = true, funcs = {}},
}

function SRBC:AddHook(hook, func)
	if Connections[hook] and type(func) == "function" then table.insert(Connections[hook].funcs, func) 
	else error("Attempt to add invalid Chaser hook", 3) end
end

function SRBC:CallHook(hook, ...)
	if Connections[hook] then
		local doOverride = false
		
		for _, func in ipairs(Connections[hook].funcs) do
			local override = func(...)
			if override then doOverride = true end
		end
		
		return doOverride and Connections[hook].override
	end
end