local RESPAWNABLE = {
	MT_BLUECRAWLA,
	MT_REDCRAWLA,
	MT_GOLDBUZZ,
	MT_REDBUZZ,
	MT_JETTBOMBER,
	MT_JETTGUNNER,
	MT_CRAWLACOMMANDER,
	MT_DETON,
	MT_SKIM,
	MT_POPUPTURRET,
	MT_SPINCUSHION,
	MT_CRUSHSTACEAN,
	MT_BANPYURA,
	MT_JETJAW,
	MT_SNAILER,
	MT_VULTURE,
	MT_ROBOHOOD,
	MT_FACESTABBER,
	MT_EGGGUARD,
	MT_GSNAPPER,
	MT_MINUS,
	MT_SPRINGSHELL,
	MT_YELLOWSHELL,
	MT_UNIDUS,
	MT_PYREFLY,
	MT_DRAGONBOMBER
}

addHook("MapLoad", function()
	SRBC.enemymemory = {}
end)

addHook("MobjDeath", function(mobj, inflictor, source, dt)
	if SRBC:IsChasers() and mobj.valid then
		for _, candidate in ipairs(RESPAWNABLE) do
			if candidate == mobj.type then
				local enemystuff = {}
				
				if mobj.spawnpoint then
					enemystuff.type = candidate
					enemystuff.x = mobj.spawnpoint.x*FU
					enemystuff.y = mobj.spawnpoint.y*FU
					enemystuff.angle = mobj.spawnpoint.angle*ANG1
					enemystuff.flip = mobj.spawnpoint.options & MTF_OBJECTFLIP
					
					if enemystuff.flip then
						enemystuff.z = R_PointInSubsector(enemystuff.x, enemystuff.y).sector.ceilingheight - mobj.spawnpoint.z*FU
					else
						enemystuff.z = R_PointInSubsector(enemystuff.x, enemystuff.y).sector.floorheight + mobj.spawnpoint.z*FU
					end
				elseif mobj.memory then
					enemystuff = mobj.memory
				end
				
				if enemystuff == {} then return end
				
				table.insert(SRBC.enemymemory, enemystuff)
				break
			end
		end
	end
end, MT_NULL)

function SRBC:RespawnEnemies()
	for _, memory in ipairs(SRBC.enemymemory) do
		local enemy = P_SpawnMobj(memory.x, memory.y, memory.z, memory.type)
		enemy.angle = memory.angle
		enemy.memory = memory
		
		if P_SupermanLook4Players(enemy) then A_FaceTarget(enemy, 0, 0) end
		
		if memory.flip then
			enemy.flags2 = $|MF2_OBJECTFLIP
		end
		
		P_SpawnMobjFromMobj(enemy, 0, 0, enemy.height/2, MT_EXITFLASH)
	end
	
	SRBC.enemymemory = {}
end

-- VV here's my catastrophically shitty old solution on full display VV
-- what was i thinking
-- this shit doesnt even work fundamentally
--[[
function SRBC:RespawnEnemies()
	for thing in mapthings.iterate do
		if thing.valid and not (thing.mobj and thing.mobj.valid and thing.mobj.health) then
			for _, candidate in ipairs(RESPAWNABLE) do
				if mobjinfo[candidate].doomednum ~= -1 and thing.type == mobjinfo[candidate].doomednum then
					local enemy = P_SpawnMobj(thing.x*FU, thing.y*FU, R_PointInSubsector(thing.x*FU, thing.y*FU).sector.floorheight + thing.z*FU, candidate)
					enemy.angle = thing.angle*ANG1
					
					if P_SupermanLook4Players(enemy) then A_FaceTarget(enemy,0,0) end
					
					if (thing.options & MTF_OBJECTFLIP) then
						enemy.flags2 = $|MF2_OBJECTFLIP
					end
					
					P_SpawnMobjFromMobj(enemy, 0, 0, enemy.height/2, MT_EXITFLASH)
					
					thing.mobj = enemy
					
					break
				end
			end
		
		end
	end
end
]]