addHook("MapLoad", function()
	if not SRBC:IsChasers() then return end
	
	SRBC.specials.exitparts = {}
	
	SRBC.goal.sector = R_PointInSubsector(SRBC.start.x, SRBC.start.y).sector
	SRBC.goal.floor = P_FloorzAtPos(SRBC.start.x, SRBC.start.y, SRBC.start.z, 64*FU)
	SRBC.goal.ceiling = P_CeilingzAtPos(SRBC.start.x, SRBC.start.y, SRBC.start.z, 64*FU)
	
	SRBC.specials.exit = P_SpawnMobj(SRBC.finish.x, SRBC.finish.y, SRBC.finish.z, MT_EXITZONE)
	SRBC.specials.exit.angle = SRBC.finish.angle
	
	for i = 0, 17 do
		local particle = P_SpawnMobjFromMobj(SRBC.specials.exit, 0, 0, 0, MT_EXITPARTICLE)
		particle.angle = ANG20*i
		particle.target = SRBC.specials.exit
		
		table.insert(SRBC.specials.exitparts, particle)
	end
	
	if mapheaderinfo[gamemap].srbc_escapex then
		local escape = P_SpawnMobj(mapheaderinfo[gamemap].srbc_escapex * FU, mapheaderinfo[gamemap].srbc_escapey * FU, mapheaderinfo[gamemap].srbc_escapez * FU, MT_EXITRING)
		escape.angle = mapheaderinfo[gamemap].srbc_escapeang * ANG1
	end
end)

addHook("PlayerThink", function(p)
	if not SRBC:IsChasers() then return end
	if not SRBC.gamestate.started then return end
	
	if SRBC:IsPlayerMobj(p) then
		if p.mo.subsector.sector then
		
			if p.mo.subsector.sector == SRBC.goal.sector and p.mo.z < SRBC.goal.ceiling and p.mo.z >= SRBC.goal.floor and not p.srbc.ghost and not p.srbc.over then
				SRBC:Lap(p)
			end
			
		end
	end
end)

addHook("TouchSpecial", function(special, mobj)
	if SRBC:IsMobjPlayer(mobj) then
		SRBC:StartGame(nil, mobj.player)
	end
	return true
end, MT_EXITZONE)

addHook("TouchSpecial", function(special, mobj)
	if SRBC:IsMobjPlayer(mobj) and SRBC.gamestate.started and not (mobj.player.srbc.ghost or mobj.player.srbc.over) then
		SRBC:PlayerFinish(mobj.player, false)
	end
	return true
end, MT_EXITRING)

addHook("MobjThinker", function(mobj)
	if mobj.valid then
		mobj.spritexscale = FU*2
		mobj.spriteyscale = FU*2
		if SRBC.gamestate.started and mobj.state == S_EXITRINGOFF then
			mobj.state = S_EXITRING
		elseif not SRBC.gamestate.started and mobj.state == S_EXITRING then
			mobj.state = S_EXITRINGOFF
		end
	end
end, MT_EXITRING)