local STARTSCORE = 1000
local MONITORSCORE = 250
local RINGSCORE = 10
local LAPSCORE = 1500

addHook("MobjDeath", function(mobj, inflictor, source, dt)
	if SRBC:IsChasers() and SRBC:IsMobjPlayer(source) then
		local p = source.player
		
		if (mobj.flags & MF_MONITOR) then P_AddPlayerScore(p, MONITORSCORE)
		elseif (mobj.type == MT_RING or mobj.type == MT_COIN) then P_AddPlayerScore(p, RINGSCORE)
		end
	end
end, MT_NULL)

addHook("MobjDamage", function(mobj, inflictor, source, dt)
	if SRBC:IsChasers() and SRBC:IsMobjPlayer(mobj) and SRBC:IsMobjPlayer(source) and SRBC:TimeSince(mobj.player.srbc.grace) > TICRATE*5 then
		local target = mobj.player
		local attacker = source.player
		
		local stolenScore = min(target.score, max(0, target.score/6))
		
		target.srbc.grace = SRBC:Timestamp()
		target.score = max(0, $-stolenScore)
		P_AddPlayerScore(attacker, stolenScore)
	end
end, MT_PLAYER)

SRBC:AddHook("ChaseStarted", function(p)
	P_AddPlayerScore(p, STARTSCORE)
end)

SRBC:AddHook("PlayerFinish", function(p, loss)
	if loss then
		p.score = max(0, $/5*4)
	else
		P_AddPlayerScore(p, (LAPSCORE*5)/(5+p.srbc.deaths) * p.srbc.laps)
		P_AddPlayerScore(p, max(1, (RINGSCORE/2)-p.srbc.deaths) * p.rings)
	end
end)