--> Override death with the *haunting* oOOoOOoo,,,
addHook("MobjDeath", function(mobj, inflictor, source, dt)
	if not SRBC:IsChasers() then return end
	if not SRBC:IsMobjPlayer(mobj) then return end
	local p = mobj.player
	p.score = max(0, $-500)
	
	if SRBC.gamestate.overtime or SRBC.gameinfo.playersleft == 1 then
		mobj.health = 1
		SRBC:PlayerFinish(p, true)
		return true
	end
	
	if p.srbc.ghost == nil then
		
		p.srbc.deaths = $+1
		p.srbc.ghost = {
			timer = 0,
			sprite = nil,
			freezeframe = nil
		}

			
		local corpse = P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_BASESPRITE)
		corpse.skin = mobj.skin
		corpse.color = mobj.color
		corpse.state = S_PLAY_DEAD
		corpse.momz = 12*FU
		corpse.fuse = TICRATE*10
		
		S_StartSound(corpse, sfx_cdfm03)
		P_DoPlayerPain(p, source, inflictor)
		
		A_SetObjectFlags(mobj, MF_SHOOTABLE, 2)
		mobj.health = 1
		
		return true
	
	else --> it's eternity in there.
		P_DoPlayerPain(p, source, inflictor)
		
		A_SetObjectFlags(mobj, MF_SHOOTABLE, 2)
		mobj.health = 1
		
		return true
	end
	
	return
end, MT_PLAYER)

addHook("ShouldDamage", function(mobj, inflictor, source, damage, dt)
	if SRBC:IsMobjPlayer(mobj) then
	
		local p = mobj.player
		
		if (dt == DMG_DEATHPIT or dt == DMG_CRUSHED) and p.srbc.ghost then
		
			local point = SRBC.finish

			if not SRBC.gamestate.started then
				if p.starpostx or p.starposty then
					point = {x = p.starpostx*FU, y = p.starposty*FU, z = p.starpostz*FU}
				else
					point = SRBC.start
				end
			end
		
			P_SetOrigin(mobj, point.x, point.y, point.z)
			S_StartSound(mobj, sfx_mixup)
			P_DoPlayerPain(p)
			P_FlashPal(p, PAL_MIXUP, 4)
		
			return false
		end
	end
end, MT_PLAYER)


--> Ghost thinker.
addHook("PostThinkFrame", function()
	for p in players.iterate do
		if SRBC:IsPlayerMobj(p) and p.srbc.ghost then
			
			p.powers[pw_shield] = 0
			p.powers[pw_underwater] = TICRATE*30
			p.rings = 0
			
			if p.srbc.ghost.timer < 1 then
				p.mo.frame = $|FF_TRANS50
				p.mo.color = SKINCOLOR_CLOUDY
			else
				
				if p.srbc.ghost.timer == TICRATE then
				
					SRBC:StoreM(p)
					SRBC:StopM(p.mo)
				
					S_StartSound(p.mo, sfx_hidden)
					p.srbc.ghost.freezeframe = p.mo.frame & ~FF_TRANS50
					p.srbc.ghost.sprite = P_SpawnMobjFromMobj(p.mo, p.mo.momx, p.mo.momy, p.mo.momz, MT_BASESPRITE)
					
					p.srbc.ghost.sprite.angle = p.drawangle
					p.srbc.ghost.sprite.skin = p.mo.skin
					p.srbc.ghost.sprite.color = p.mo.color
					p.srbc.ghost.sprite.frame = p.mo.frame
					p.srbc.ghost.sprite.sprite2 = p.mo.sprite2
					
					A_SetObjectFlags(p.srbc.ghost.sprite, MF_NOGRAVITY, 2)
					A_SetObjectFlags(p.mo, MF_SHOOTABLE, 1)
					
					p.mo.flags2 = $|MF2_DONTDRAW
					
				end
				
				if p.srbc.ghost.timer == 1 then
					p.mo.flags2 = $ & ~MF2_DONTDRAW
					p.mo.frame = $ & ~FF_TRANS50
					p.mo.color = p.skincolor
					
					A_SetObjectFlags(p.mo, MF_SHOOTABLE, 2)
					P_RemoveMobj(p.srbc.ghost.sprite)
					SRBC:ReleaseM(p)
					
					p.srbc.ghost = nil
					return
				elseif p.srbc.ghost.sprite and p.srbc.ghost.sprite.valid then
				
					p.mo.flags2 = $|MF2_DONTDRAW
					SRBC:StopM(p.mo)
				
					if p.srbc.ghost.timer <= TICRATE/5 then
						p.srbc.ghost.sprite.frame = p.srbc.ghost.freezeframe|FF_TRANS10
					elseif p.srbc.ghost.timer <= TICRATE/5*2 then
						p.srbc.ghost.sprite.frame = p.srbc.ghost.freezeframe|FF_TRANS20
						p.srbc.ghost.sprite.color = p.skincolor
					elseif p.srbc.ghost.timer <= TICRATE/5*3 then
						p.srbc.ghost.sprite.frame = p.srbc.ghost.freezeframe|FF_TRANS30
					elseif p.srbc.ghost.timer <= TICRATE/5*4 then
						p.srbc.ghost.sprite.frame = p.srbc.ghost.freezeframe|FF_TRANS40
					else
						p.srbc.ghost.sprite.frame = p.srbc.ghost.freezeframe|FF_TRANS50
					end
				end
				
				p.srbc.ghost.timer = $-1
			end
			
		end
	end
end)

--> Universal player revive function ! !
function SRBC:ReviveGhost(p, savior)
	if SRBC:IsPlayerMobj(p) then
		if p.srbc.ghost then
		
			p.srbc.ghost.timer = TICRATE
			
			if savior == nil then return end
			if p ~= savior then 
				chatprint("\139*"..savior.name.." revived "..p.name.."!", true)
			else
				chatprint("\139*"..p.name.." revived themselves!", true)
			end
		
		end
	end
end



--> Always spawn alive 'n kickin.
addHook("MapChange", function()
	for p in players.iterate do
		if p.valid then
			p.srbc.ghost = nil
			p.srbc.deaths = 0
		end
	end
end)


--> Can't damage while dead.
addHook("ShouldDamage", function(mobj, inflictor, source, damage, dt)
	if (mobj.flags & MF_MONITOR) then
		if SRBC:IsMobjPlayer(source) and source.player.srbc.ghost then SRBC:ReviveGhost(source.player) end
	return end -- because this shit causes a stack overflow otherwise, might aswell make it a mechanic.
	
	if SRBC:IsMobjPlayer(source) and source.player.srbc.ghost then return false end
end, MT_NULL)


--> Can't get rings either! Yer dead, buddy.
addHook("TouchSpecial", function(sMobj, mobj)
	if SRBC:IsMobjPlayer(mobj) and mobj.player.srbc.ghost then
		return true
	end
end, MT_RING)

--> Contact revive.
addHook("MobjCollide", function(mobj, moverMobj)
	if SRBC:IsMobjPlayer(mobj) and SRBC:IsMobjPlayer(moverMobj) then
		if mobj.player.srbc.ghost == nil and moverMobj.player.srbc.ghost ~= nil and moverMobj.player.srbc.ghost.timer < 1 and not moverMobj.player.powers[pw_flashing] then
			SRBC:ReviveGhost(moverMobj.player, mobj.player)
		elseif moverMobj.player.srbc.ghost == nil and mobj.player.srbc.ghost ~= nil and mobj.player.srbc.ghost.timer < 1 and not mobj.player.powers[pw_flashing] then
			SRBC:ReviveGhost(mobj.player, moverMobj.player)
		end
		
	end
end, MT_PLAYER)