
addHook("MapChange", function()
	for p in players.iterate do
		if p.valid then
			p.srbc.over = 0
			p.srbc.lose = false
		end
	end
end)

function SRBC:PlayerFinish(p, loss)
	if not SRBC:IsPlayerMobj(p) or p.srbc.over or not SRBC:IsChasers() or not SRBC.gamestate.started then return end
	
	if SRBC:CallHook("PlayerFinish", p, loss) then return end
	
	A_SetObjectFlags(p.mo, MF_SHOOTABLE, 1)
	SRBC:StopM(p.mo)
	p.srbc.storedAngle = p.mo.angle
	
	S_StartSound(p.mo, sfx_cdfm31)
	p.srbc.over = SRBC:Timestamp()
	p.srbc.lose = loss
	
	p.srbc.endinfo = {score = p.score, rings = p.rings, laps = 0, done = false}
	
	P_SpawnMobjFromMobj(p.mo, 0, 0, p.mo.height/2, MT_EXITFLASH)
	
	if not loss then
		P_AddPlayerScore(p, p.srbc.laps * 1500 + 5 * p.rings)
		chatprint("\132*"..p.name.." finished!", true)
	else
		chatprint("\132*"..p.name.." took an L...", true)
	end
end

addHook("ThinkFrame", function()
	if not SRBC:IsChasers() then return end
	
	for p in players.iterate do
		if p.valid and SRBC:TimeSince(p.srbc.over) < 12*TICRATE then return end
	end
	
	G_ExitLevel()
end)

addHook("PlayerThink", function(p)
	if not SRBC:IsChasers() then return end
	
	if SRBC:IsPlayerMobj(p) and p.srbc.over then
		p.powers[pw_nocontrol] = 2
		p.mo.flags2 = $|MF2_DONTDRAW
		
		A_SetObjectFlags(p.mo, MF_SHOOTABLE, 1)
		SRBC:StopM(p.mo)
		p.mo.angle = p.srbc.storedAngle
		
		if SRBC:TimeSince(p.srbc.over) == TICRATE/2 and p == consoleplayer then
			if p.srbc.lose then
				SRBC:PlayJingle("CHFAIL", TICRATE*5)
			else
				SRBC:PlayJingle("CHPASS", TICRATE*9)
			end
			
		end
	end
end)