-- because chaser maps are built with specific shields only in mind.
-- mystery box comes at a huge cost so it's fine.

local Restrictions = {}
addHook("NetVars", function(net) Restrictions = net($) end)

local REFUNDS = {
	[MT_ATTRACT_BOX] = 25,
	[MT_FORCE_BOX] = 20,
	[MT_ARMAGEDDON_BOX] = 35,
	[MT_WHIRLWIND_BOX] = 55,
	[MT_ELEMENTAL_BOX] = 40,
	[MT_SNEAKERS_BOX] = 15,
	[MT_INVULN_BOX] = 45,
	[MT_FLAMEAURA_BOX] = 50,
	[MT_BUBBLEWRAP_BOX] = 30,
	[MT_THUNDERCOIN_BOX] = 60
}

addHook("MapLoad", function()
	if not SRBC:IsChasers() then return end
	
	Restrictions = {}
	for k, _ in pairs(REFUNDS) do
		Restrictions[k] = true
	end
	
	for mobj in mobjs.iterate() do
		if mobj.valid and Restrictions[mobj.type] then Restrictions[mobj.type] = false end
	end
	
	Restrictions[MT_INVULN_BOX] = true
	Restrictions[MT_SNEAKERS_BOX] = true
end)



local function RefundBox(mobj)
	if SRBC:IsChasers() and mobj.valid and mobj.skipthrown and Restrictions[mobj.type] then
		if mobj.skipskip then
			S_StopSoundByID(mobj.skipskip, sfx_addfil)
			S_StartSound(mobj.skipskip, sfx_notadd, mobj.skipskip.player)
			
			if not CV_FindVar("infinitescrap").value then
				mobj.skipskip.player.skipscrap = $ + REFUNDS[mobj.type]
			end
		end
		
		P_RemoveMobj(mobj)
	end
end

for k, _ in pairs(REFUNDS) do
	addHook("MobjThinker", RefundBox, k)
end