local tabstats = function(v)
	if not SRBC:IsChasers() then return end
	
	local P_Info = v.cachePatch("SRBC_INFOBORDER")
	local P_Hint = v.cachePatch("SRBC_HINTBORDER")
	local P_Play = v.cachePatch("SRBC_PLAYBORDER")
	
	v.drawFill(18, 10, 66, 98, 254|V_TRANSLUCENT|V_SNAPTOTOP|V_SNAPTORIGHT)
	v.drawFill(18, 116, 66, 66, 254|V_TRANSLUCENT|V_SNAPTOTOP|V_SNAPTORIGHT)
	v.drawFill(96, 10, 206, 172, 254|V_TRANSLUCENT|V_SNAPTOTOP|V_SNAPTORIGHT)
	
	
	local partime = "N/A"
	if mapheaderinfo[gamemap].srbc_partime then partime = SRBC:TicsToTime(mapheaderinfo[gamemap].srbc_partime*TICRATE) end
	
	local plural = " Players"
	if SRBC.gameinfo.playercount == 1 then plural = " Player" end
	
	v.drawString(300, 11, tostring(SRBC.gameinfo.playercount)..plural, V_SNAPTOTOP|V_SNAPTORIGHT|V_YELLOWMAP, "right")
	v.drawString(98, 11, "PAR: "..partime, V_SNAPTOTOP|V_SNAPTORIGHT|V_YELLOWMAP, "left")
	
	
	local index_x = 97
	local index_y = 21
	
	local P_Score = v.cachePatch("SRBC_TABSCR")
	local P_Laps = v.cachePatch("SRBC_TABLAP")
	local P_Rings = v.cachePatch("SRBC_TABRNG")
	
	if SRBC.gameinfo.playercount > 20 then -- Mini
		
		for p in players.iterate do
			if not p.valid then continue end
			
			local P_Icon = v.getSprite2Patch(p.skin, SPR2_LIFE)
			local chatColor = skincolors[max(1, p.skincolor)].chatcolor
			
			local playerOut = 0
			if p.srbc.over or p.srbc.ghost then playerOut = V_TRANSLUCENT end
			
			v.drawScaled((index_x + 4)*FU, (index_y + 7)*FU, FU/2, P_Icon, playerOut|V_SNAPTOTOP|V_SNAPTORIGHT, v.getColormap(p.skin, max(1, p.skincolor)))
			v.drawString(index_x + 8, index_y+1, p.name, V_ALLOWLOWERCASE|V_SNAPTOTOP|V_SNAPTORIGHT|chatColor, "thin")
			v.drawString(index_x + 102, index_y+1, p.score, V_SNAPTOTOP|V_SNAPTORIGHT, "thin-right")
			
			if index_x == 199 then
				index_y = $+10
				index_x = $-102
			else
				index_x = $+102
			end
		end
		
	elseif SRBC.gameinfo.playercount > 5 then -- Small
	
		for p in players.iterate do
			if not p.valid then continue end
			
			local P_Icon = v.getSprite2Patch(p.skin, SPR2_LIFE)
			local chatColor = skincolors[max(1, p.skincolor)].chatcolor
			
			local playerOut = 0
			if p.srbc.over or p.srbc.ghost then playerOut = V_TRANSLUCENT end
			
			v.draw(index_x + 8, index_y + 12, P_Icon, playerOut|V_SNAPTOTOP|V_SNAPTORIGHT, v.getColormap(p.skin, max(1, p.skincolor)))
			
			v.draw(index_x + 16, index_y + 8, P_Score, V_SNAPTOTOP|V_SNAPTORIGHT)
			v.draw(index_x + 94, index_y + 8, P_Laps, V_SNAPTOTOP|V_SNAPTORIGHT)
			
			v.drawString(index_x + 16, index_y, p.name, V_ALLOWLOWERCASE|V_SNAPTOTOP|V_SNAPTORIGHT|chatColor, "thin")
			v.drawString(index_x + 24, index_y + 8, p.score, V_SNAPTOTOP|V_SNAPTORIGHT, "left")
			v.drawString(index_x + 94, index_y + 8, p.srbc.laps, V_SNAPTOTOP|V_SNAPTORIGHT, "right")
			
			if index_x == 199 then
				index_y = $+16
				index_x = $-102
			else
				index_x = $+102
			end
		end
	
	else -- Big
			
		for p in players.iterate do
			if not p.valid then continue end
			
			local P_Icon = v.getSprite2Patch(p.skin, SPR2_LIFE)
			local chatColor = skincolors[max(1, p.skincolor)].chatcolor
			
			local playerOut = 0
			if p.srbc.over or p.srbc.ghost then playerOut = V_TRANSLUCENT end
			
			v.drawScaled((index_x + 18)*FU, (index_y + 24)*FU, FU*2, P_Icon, playerOut|V_SNAPTOTOP|V_SNAPTORIGHT, v.getColormap(p.skin, max(1, p.skincolor)))
			
			v.draw(index_x + 36, index_y + 8, P_Score, V_SNAPTOTOP|V_SNAPTORIGHT)
			v.draw(index_x + 36, index_y + 16, P_Laps, V_SNAPTOTOP|V_SNAPTORIGHT)
			v.draw(index_x + 36, index_y + 24, P_Rings, V_SNAPTOTOP|V_SNAPTORIGHT)
			
			v.drawString(index_x + 36, index_y, p.name, V_ALLOWLOWERCASE|V_SNAPTOTOP|V_SNAPTORIGHT|chatColor, "left")
			v.drawString(index_x + 45, index_y + 8, p.score, V_SNAPTOTOP|V_SNAPTORIGHT, "left")
			v.drawString(index_x + 45, index_y + 16, p.srbc.laps, V_SNAPTOTOP|V_SNAPTORIGHT, "left")
			v.drawString(index_x + 45, index_y + 24, p.rings, V_SNAPTOTOP|V_SNAPTORIGHT|V_YELLOWMAP, "left")
			
			index_y = $+32
		end
	end
	
	if SRBC:IsPlayerMobj(displayplayer) and mapheaderinfo[gamemap].srbc_escapex then
		local p = displayplayer
		
		local pointerAngle = R_PointToAngle2(p.mo.x, p.mo.y, mapheaderinfo[gamemap].srbc_escapex*FU, mapheaderinfo[gamemap].srbc_escapey*FU) - p.mo.angle
		
		local P_Pointer = v.getSpritePatch(SPR_CTAB, A, 0, pointerAngle)
		v.draw(51, 149, P_Pointer, V_SNAPTOTOP|V_SNAPTORIGHT)
		
		v.drawString(51, 14, "AVG: "..SRBC:TicsToTime(p.srbc.timeaverage, true), V_SNAPTOTOP|V_SNAPTORIGHT|V_GREENMAP, "small-center")
		
		for i, lap in ipairs(p.srbc.laptimes) do
			if i == 10 then break end
			v.drawString(51, 14 + i*9, SRBC:TicsToTime(lap, true), V_SNAPTOTOP|V_SNAPTORIGHT, "center")
		end
	end
	
	
	
	v.draw(16, 8, P_Info, V_SNAPTOTOP|V_SNAPTORIGHT)
	v.draw(16, 114, P_Hint, V_SNAPTOTOP|V_SNAPTORIGHT)
	v.draw(94, 8, P_Play, V_SNAPTOTOP|V_SNAPTORIGHT)
	
end

customhud.SetupItem("rankings", "chasers", tabstats, "scores", 3)



local timer = function(v, p)

	if SRBC:IsChasers() and SRBC.gamestate.started then
		
		local P_Timebar = v.cachePatch("SRBC_TIMEBAR")
		
		local fxTimer = SRBC:SinceStart()*FU
		local bar_in = ease.inoutquint(min(FixedDiv(fxTimer - TICRATE*3*FU, TICRATE*2*FU), FU), 82, 0)
		
		v.draw(240 + bar_in, 10, P_Timebar, V_HUDTRANS|V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER)
		
		if SRBC.gamestate.overtime then
			local Bar_Width = ease.linear(FixedDiv(SRBC:PlayerOvertime(p)*FU, SRBC.gameinfo.maxtimer*FU), 0, 60)
			v.drawFill(242, 12, Bar_Width, 8, 36|V_HUDTRANS|V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER)
			v.drawString(272, 12, SRBC:TicsToTime(max(0, SRBC:PlayerOvertime(p))), V_HUDTRANS|V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_REDMAP, "center")
		else
			local Bar_Width = ease.linear(FixedDiv(fxTimer, SRBC.gameinfo.maxtimer*FU), 60, 0)
			v.drawFill(242 + bar_in, 12, Bar_Width, 8, 154|V_HUDTRANS|V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER)
			v.drawString(272 + bar_in, 12, SRBC:TicsToTime(max(0, SRBC.gameinfo.maxtimer - SRBC:SinceStart())), V_HUDTRANS|V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER, "center")
		end

	end
end

customhud.SetupItem("timer", "chasers", timer, "game", 1)



local hudanimations = function(v)
	if SRBC:IsChasers() then
		if SRBC.gamestate.started then -- ya never know
			
			local fxTimer = SRBC:SinceStart()
			
			if fxTimer < TICRATE*4 then
				
				local zig_inout = FU
				
				if fxTimer < TICRATE then
					zig_inout = FixedDiv(fxTimer*FU, TICRATE*FU)
				elseif fxTimer > TICRATE*3 then
					zig_inout = FU - FixedDiv((fxTimer - TICRATE*3)*FU, TICRATE*FU)
				end
				
				zig_inout = ease.inoutquint($, 0, 42*FU)
				
				
				local scroll = fxTimer % 32 * FU
				local textscroll = fxTimer % 64 * FU
				
				local P_TopZig = v.cachePatch("SRBC_BLUZIG1")
				local P_TopTrim = v.cachePatch("SRBC_ZIGTRIM1")
				local P_BotZig = v.cachePatch("SRBC_BLUZIG2")
				local P_BotTrim = v.cachePatch("SRBC_ZIGTRIM2")
				local P_TextBar = v.cachePatch("SRBC_RACESTART")
				
				--// this is quite ridiculous
				
				--// Main Trim
				v.drawScaled(-scroll, FU*-42 + zig_inout, FU, P_TopTrim, V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT)
				v.drawScaled(FU*-32 + scroll, FU*200 - zig_inout, FU, P_BotTrim, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
				
				--// Layer Trim
				v.drawScaled(FU*-32 + scroll, FU*-46 + zig_inout, FU, P_TopTrim, V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT)
				v.drawScaled(-scroll, FU*204 - zig_inout, FU, P_BotTrim, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
				
				--// Layer Zig
				v.drawScaled(FU*-32 + scroll, FU*-46 + zig_inout, FU, P_TopZig, V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT)
				v.drawScaled(-scroll, FU*204 - zig_inout, FU, P_BotZig, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
				
				--// Main Zig
				v.drawScaled(-scroll, FU*-42 + zig_inout, FU, P_TopZig, V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT)
				v.drawScaled(FU*-32 + scroll, FU*200 - zig_inout, FU, P_BotZig, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
				
				--// Text
				v.drawScaled(FU*-64 + textscroll, FU*-34 + zig_inout, FU, P_TextBar, V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT)
				v.drawScaled(-textscroll, FU*226 - zig_inout, FU, P_TextBar, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
			
			elseif fxTimer > SRBC.gameinfo.maxtimer - TICRATE*3 and SRBC:SinceOvertime() < TICRATE*2 then
				
				-- D.R.Y code? what's that! :3
				
				fxTimer = $ - (SRBC.gameinfo.maxtimer - TICRATE*3)
				
				local zig_inout = FU
				
				if fxTimer < TICRATE*3 then
					zig_inout = FixedDiv(fxTimer*FU, TICRATE*3*FU)
				elseif fxTimer > TICRATE*4 then
					zig_inout = FU - FixedDiv((fxTimer - TICRATE*4)*FU, TICRATE*FU)
				end
				
				
				
				local text_inout = 0
				
				if fxTimer > TICRATE*4 then
					text_inout = FU - FixedDiv((fxTimer - TICRATE*4)*FU, TICRATE*FU)
				elseif fxTimer > TICRATE*2 then
					text_inout = min(FixedDiv((fxTimer - TICRATE*2)*FU, TICRATE*FU), FU)
				end
				
				text_inout = ease.inoutquint($, 0, 34*FU)
				zig_inout = ease.inoutquad($, 0, 34*FU)
				
				local scroll = fxTimer % 32 * FU
				local textscroll = fxTimer % 96 * FU
				
				local P_TopZig = nil
				local P_BotZig = nil
				local P_TextBar = nil
				
				if SRBC.gamestate.overtime then
					P_TopZig = v.cachePatch("SRBC_REDZIG1")
					P_BotZig = v.cachePatch("SRBC_REDZIG2")
					P_TextBar = v.cachePatch("SRBC_DEATH")
				else
					P_TopZig = v.cachePatch("SRBC_BLUZIG1")
					P_BotZig = v.cachePatch("SRBC_BLUZIG2")
					P_TextBar = v.cachePatch("SRBC_SUDDEN")
				end
				
				local P_TopTrim = v.cachePatch("SRBC_ZIGTRIM1")
				local P_BotTrim = v.cachePatch("SRBC_ZIGTRIM2")
				
				
				--// Main Trim
				v.drawScaled(-scroll, FU*-42 + zig_inout, FU, P_TopTrim, V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT)
				v.drawScaled(FU*-32 + scroll, FU*200 - zig_inout, FU, P_BotTrim, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
				
				--// Layer Trim
				v.drawScaled(FU*-32 + scroll, FU*-46 + zig_inout, FU, P_TopTrim, V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT)
				v.drawScaled(-scroll, FU*204 - zig_inout, FU, P_BotTrim, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
				
				--// Layer Zig
				v.drawScaled(FU*-32 + scroll, FU*-46 + zig_inout, FU, P_TopZig, V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT)
				v.drawScaled(-scroll, FU*204 - zig_inout, FU, P_BotZig, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
				
				--// Main Zig
				v.drawScaled(-scroll, FU*-42 + zig_inout, FU, P_TopZig, V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT)
				v.drawScaled(FU*-32 + scroll, FU*200 - zig_inout, FU, P_BotZig, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
				
				--// Text
				v.drawScaled(FU*-96 + textscroll, FU*-34 + text_inout, FU, P_TextBar, V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT)
				v.drawScaled(-textscroll, FU*226 - text_inout, FU, P_TextBar, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
				
			end
			
		end
	end
end

customhud.SetupItem("hudanims", "chasers", hudanimations, "gameandscores", 2)



local laptime = function(v, p)
	if SRBC:IsChasers() then
		
		v.drawString(160, 1, "all hud and gui is wip!", V_TRANSLUCENT|V_SNAPTOTOP|V_SNAPTORIGHT|V_GREENMAP, "thin-center")
		
		local P_Time = v.cachePatch("STTTIME")
		local P_Colon = v.cachePatch("STTCOLON")
		local P_Period = v.cachePatch("STTPERIO")
		
		local last = SRBC.gamestate.started
		for _, lap in ipairs(p.srbc.laptimes) do
			last = $ + lap
		end
		local laptime = SRBC:TimeSince(last) - SRBC:TimeSince(p.srbc.over)
		
		v.draw(16, 26, P_Time, V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
		v.drawPaddedNum(72, 26, G_TicsToMinutes(laptime, true), 2, V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
		v.draw(72, 26, P_Colon, V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
		v.drawPaddedNum(96, 26, G_TicsToSeconds(laptime), 2, V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
		v.draw(96, 26, P_Period, V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
		v.drawPaddedNum(120, 26, G_TicsToCentiseconds(laptime), 2, V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
		
	end
end

customhud.SetupItem("time", "chasers", laptime)



local laps = function(v, p)
	if SRBC:IsChasers() and SRBC_CONVAR.showlaps then
		
		local P_Lap = v.cachePatch("SRBC_LAPICON")
		
		for i = 1, min(p.srbc.laps, 8) do
			v.draw(288 - (15 * (i-1)), 27, P_Lap, V_HUDTRANS|V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER)
		end
		
	end
end

customhud.SetupItem("laps", "chasers", laps, "game", 1)



local endscreen = function(v, p)
	if SRBC:IsChasers() and SRBC:IsPlayerMobj(p) then
		if SRBC:TimeSince(p.srbc.over) then
			
			local fxTimer = SRBC:TimeSince(p.srbc.over)
			
			v.drawFill(18, 62, 284, 66, 254|V_TRANSLUCENT|V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
			
			local P_Score = v.cachePatch("STTSCORE")
			local P_Rings = v.cachePatch("STTRINGS")
			local P_Colon = v.cachePatch("STTCOLON")
			local P_Period = v.cachePatch("STTPERIO")
			
			local P_Box = v.cachePatch("SRBC_ENDBORDER")
			local P_You = v.cachePatch("SRBC_YOU")
			
			local P_Result = nil
			local P_Player = nil
			
			local Colormap = v.getColormap(p.skin, max(1, p.skincolor))
			
			if p.srbc.lose then
				P_Result = v.cachePatch("SRBC_LOSE")
				P_Player = v.getSprite2Patch(p.skin, SPR2_DEAD)
			else
				P_Result = v.cachePatch("SRBC_WIN")
				P_Player = v.getSprite2Patch(p.skin, SPR2_RUN, false, (leveltime/2) % (skins[p.skin].sprites[SPR2_RUN].numframes), 3)
			end
			
			v.drawScaled(50*FU, 108*FU, FU/2, P_Player, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER, Colormap)
			
			v.draw(79, 67, P_You, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
			v.draw(106, 67, P_Result, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
			
			v.draw(79, 84, P_Rings, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
			v.draw(79, 99, P_Score, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
			
			v.draw(16, 60, P_Box, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
			
			local DisplayScore = p.srbc.endinfo.score
			local DisplayRings = p.srbc.endinfo.rings
			
			
			
			if fxTimer >= TICRATE*2 and fxTimer % (TICRATE/2) == 0 and p.srbc.endinfo.laps < min(8, p.srbc.laps) then
				p.srbc.endinfo.laps = $+1
				S_StartSound(nil, sfx_tink, p)
			end
			
			if not p.srbc.lose then DisplayScore = $ + p.srbc.endinfo.laps * 1500 end
			
			local RingWait = TICRATE*2 + TICRATE/2 + min(8, p.srbc.laps) * TICRATE/2
			
			if fxTimer > RingWait and not p.srbc.lose then
				local Count = min(DisplayRings, (fxTimer - RingWait)*3)
				DisplayRings = $ - Count
				DisplayScore = $ + Count*5
				
				if DisplayRings > 0 then
					S_StartSound(nil, sfx_ptally, p)
				end
			end
			
			if DisplayRings == 0 and not p.srbc.endinfo.done and not p.srbc.lose then
				p.srbc.endinfo.done = true
				S_StartSound(nil, sfx_chchng, p)
			end
			
			if p.srbc.endinfo.laps then
				
				local index_x = 179
				local index_y = 71
			
				for i = 1, p.srbc.endinfo.laps do
					local laptime = p.srbc.laptimes[i]
						
					v.drawPaddedNum(index_x, index_y, G_TicsToMinutes(laptime, true), 2, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
					v.draw(index_x, index_y, P_Colon, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
					v.drawPaddedNum(index_x + 24, index_y, G_TicsToSeconds(laptime), 2, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
					v.draw(index_x + 24, index_y, P_Period, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
					v.drawPaddedNum(index_x + 47, index_y, G_TicsToCentiseconds(laptime), 2, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
					
					if i % 4 == 0 then
						index_x = $+71
						index_y = 71
					else
						index_y = $+13
					end
				
				end
			end
			
			v.drawPaddedNum(155, 85, DisplayRings, min(4, tostring(DisplayRings):len()), V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
			v.drawPaddedNum(151, 113, DisplayScore, min(9, tostring(DisplayScore):len()), V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
			
		end	
	end
end

customhud.SetupItem("endscreen", "chasers", endscreen, "game", 2)