--// Freeslotting //--

freeslot("TOL_CHASERS")

freeslot("MT_BASESPRITE", "S_PLAY_NOSTATE")
freeslot("MT_EXITZONE", "S_EXITZONE", "MT_EXITPARTICLE", "S_EXITPARTICLE")

freeslot("MT_EXITRING", "S_EXITRING", "S_EXITRINGOFF", "SPR_BIGR")
freeslot("MT_EXITFLASH", "S_EXITFLASH", "SPR_FLSH")

freeslot("SPR_CTAB")

--// Asset Init //--

G_AddGametype({
	name = "Chasers",
	identifier = "Chasers",
	typeoflevel = TOL_CHASERS,
	rules = GTR_SPAWNENEMIES|GTR_NOTITLECARD,
	description = "From finish to start, run for glory, and your life!",
	headercolor = 134,
	intermissiontype = int_match
})

if MapVote then
	MapVote.RegisterGametype(GT_CHASERS, "Chasers", 0, 0, TOL_CHASERS)
end

states[S_PLAY_NOSTATE] = {
	sprite = SPR_PLAY,
	frame = SPR2_STND,
	tics = -1,
	action = nil,
	var1 = 0,
	var2 = 0,
	nextstate = S_NULL
}

mobjinfo[MT_BASESPRITE] = {
	doomednum = -1,
	spawnstate = S_PLAY_NOSTATE,
	dispoffset = 0,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT
}


--// Game Vars //--

rawset(_G, "SRBC", {
	start = {x = 0, y = 0, z = 0, angle = 0},
	finish = {x = 0, y = 0, z = 0, angle = 0, flip = 0},
	goal = {sector = nil, floor = 0, ceiling = 0},
	specials = {exit = nil, exitparts = {}, goal = nil},
	enemymemory = {},

	gamestate = {started = 0, gameover = 0, overtime = 0, faceoff = 0},
	gameinfo = {maxtimer = 0, playercount = 0, playersleft = 0, ghosts = 0},
	
	jingleTime = 0,
	musicTime = 0,
	debug = false
	
})

rawset(_G, "SRBC_CONVAR", {
	-- client --
	showlaps = true,
	screenshake = 2,
	
	musicProfile = "chasers",
	music = {
		["chasers"] = {
			game = "ESCAPE",
			overtime = "SDEATH",
			description = "Custom OST for Chasers by Saxashitter."
		},
		["metalrace"] = {
			game = "BCZ1",
			overtime = "VSMETL",
			description = "Nothing beats good ol' BCZ soundtrack. <3"
		},
		["custom"] = {
			game = "BCZ1",
			overtime = "VSMETL",
			description = "Music profile used by the\x82 srbc_customizemusic\x80 command."
		}
	}
})

-- to add custom music:

--> make a pk3 with some music lumps and a lua file.
--[[
	SRBC_CONVAR.music["PROFILENAME"] = {
		game = "CHASEMUSICLUMPNAME",
		overtime = "SUDDENDEATHMUSICLUMPNAME",
		description = "Look at me! I'm a cool custom music option added by this server!"
	}
]]
--> thats it lol
--> make sure to load it **after** srb chasers.

-- i tried writing this mod in a way where it's easily externally moddable through hooks and function overrides. go ham, just follow the rules.

addHook("NetVars", function(net)
	SRBC.start = net($)
	SRBC.finish = net($)
	SRBC.goal = net($)
	SRBC.specials = net($)
	SRBC.gamestate = net($)
	SRBC.gameinfo = net($)
	SRBC.enemymemory = net($)
end)


--// Constants //--

--, none yet. lol


--// Load Order //--

local loadOrder = {
	"External/l_lib-customhud-v2-1.lua",
	"Core/Functions.lua",
	"Core/Housekeeping.lua",
	"Core/Signals.lua",
	"Core/Console.lua",
	"Objects/Goal.lua",
	"Objects/Exit.lua",
	"Features/Player/Ghost.lua",
	"Features/Player/Over.lua",
	"Features/Player/Nerfed.lua",
	"Features/Player/Tweaks.lua",
	"Features/Special/SkipLimit.lua",
	"Features/Game/Level.lua",
	"Features/Game/Chasers.lua",
	"Features/Game/Enemies.lua",
	"Features/Game/Score.lua",
	"Features/Game/Music.lua",
	"Hud/Default.lua",
	"Hud/All.lua",
	"Features/Player/VFX.lua"
}

for _, entry in ipairs(loadOrder) do
	dofile(entry)
end


